"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Admin = exports.Owner = exports.Member = exports.Public = exports.All = exports.Delete = exports.Patch = exports.Post = exports.Put = exports.Get = void 0;
const controller_meta_1 = require("../metadata/controller.meta");
const method_meta_1 = require("../metadata/method.meta");
function Get(path = '') {
    return (proto, name, value) => {
        const method = new controller_meta_1.ControllerMeta(proto).getMethod(name);
        method.action = 'get';
        method.path = path;
        method.ref = value.value;
    };
}
exports.Get = Get;
function Put(path = '') {
    return (proto, name, value) => {
        const method = new controller_meta_1.ControllerMeta(proto).getMethod(name);
        method.action = 'put';
        method.path = path;
        method.ref = value.value;
    };
}
exports.Put = Put;
function Post(path = '') {
    return (proto, name, value) => {
        const method = new controller_meta_1.ControllerMeta(proto).getMethod(name);
        method.action = 'post';
        method.path = path;
        method.ref = value.value;
    };
}
exports.Post = Post;
function Patch(path = '') {
    return (proto, name, value) => {
        const method = new controller_meta_1.ControllerMeta(proto).getMethod(name);
        method.action = 'patch';
        method.path = path;
        method.ref = value.value;
    };
}
exports.Patch = Patch;
function Delete(path = '') {
    return (proto, name, value) => {
        const method = new controller_meta_1.ControllerMeta(proto).getMethod(name);
        method.action = 'delete';
        method.path = path;
        method.ref = value.value;
    };
}
exports.Delete = Delete;
function All(path = '') {
    return (proto, name, value) => {
        const method = new controller_meta_1.ControllerMeta(proto).getMethod(name);
        method.action = 'delete';
        method.path = path;
        method.ref = value.value;
    };
}
exports.All = All;
function Public() {
    return (proto, name, value) => {
        const method = new controller_meta_1.ControllerMeta(proto).getMethod(name);
        method.role = method_meta_1.Role.Public;
    };
}
exports.Public = Public;
function Member() {
    return (proto, name, value) => {
        const method = new controller_meta_1.ControllerMeta(proto).getMethod(name);
        method.role = method_meta_1.Role.Member;
    };
}
exports.Member = Member;
function Owner() {
    return (proto, name, value) => {
        const method = new controller_meta_1.ControllerMeta(proto).getMethod(name);
        method.role = method_meta_1.Role.Owner;
    };
}
exports.Owner = Owner;
function Admin() {
    return (proto, name, value) => {
        const method = new controller_meta_1.ControllerMeta(proto).getMethod(name);
        method.role = method_meta_1.Role.Admin;
    };
}
exports.Admin = Admin;
