import { Request as TReq, Response as TRes } from 'lambda-api';
import { ZodTypeAny } from 'zod';
export type TGetter = (data: any, req: TReq, res: TRes) => any;
export type TValidator = ZodTypeAny | undefined;
export declare enum Role {
    Admin = "ADMIN",
    Owner = "OWNER",
    Member = "MEMBER",
    Public = "PUBLIC"
}
export interface TApiConfig {
    action: string;
    path: string;
    method: string;
    role: Role;
}
export interface TParam {
    getter: TGetter;
    validator: TValidator;
    data: string;
    type?: Function;
}
export declare class MethodMeta {
    name: string;
    path: string;
    action: string;
    ref: Function | null;
    role: Role | null;
    params: TParam[];
    constructor(name: string);
    bindApi(api: any, basePath: string, proto: Function): TApiConfig;
}
